<?php


namespace app\mz_chacm\controller;


use think\facade\Db;
use think\facade\View;

class Index
{
    public function index(){
        $name = Db::name('mz_chacm_province')->select()->toArray();
        View::assign([
           'name'=>$name
        ]);
        return View::fetch();
    }
    public function cha(){
        $pid = input('pid');
        $code = input('code');
        $name = input('name');
        $sheng = Db::name('mz_chacm_province')->select()->toArray();
        if ($name){
            if (!$code){
                return json(['code'=>-2,'msg'=>'卡密不存在！-']);
            }
            $kami = Db::name('mz_chacm_kami')->where(['pid'=>$pid,'code'=>$code])->find();
            if (!$kami){
                return json(['code'=>-2,'msg'=>'卡密不存在！']);
            }else{
                if (!$kami['end_time']){
                    Db::name('mz_chacm_kami')->where(['pid'=>$pid,'code'=>$code])->update(['end_time'=>(time() + $kami['day'] * 86400 ),'ip'=>getip()]);
                }elseif ($kami['end_time'] < time() ){
                    return json(['code'=>-2,'msg'=>'卡密已过期！']);
                }
            }
            $log = Db::name('mz_chacm_log')->where(['pid'=>$pid,'name'=>$name])->find();
            if ($log && $log['data']){
                $data = json_decode($log['data'] , true);
            }else{
                foreach ($sheng as $i=>$v){
                    $data[$i] = [
                        'name'=>$v['name'],
                        'number' => rand($v['min'], $v['max']),
                    ];
                }
                Db::name('mz_chacm_log')->save(['name'=>$name,'data'=>json_encode($data,256),'create_time'=>time(),'pid'=>$pid]);
            }
            $edit = array_column($data,'number');
            array_multisort($edit,SORT_DESC,$data);
        }else{
            foreach ($sheng as $i=>$v){
                $data[$i] = [
                    'name'=>$v['name'],
                    'number' => 0,
                ];
            }
        }
        return json(['code'=>1,'data'=>$data]);
    }
    public function jihuo(){
        $pid = input('pid');
        $code = input('code');
        $kami = Db::name('mz_chacm_kami')->where(['pid'=>$pid,'code'=>$code])->find();
        if (!$kami){
            return json(['code'=>-1,'msg'=>'卡密不存在！']);
        }else{
            if (!$kami['end_time']){
                $end_time = time() + $kami['day'] * 86400;
                Db::name('mz_chacm_kami')->where(['pid'=>$pid,'code'=>$code])->update(['end_time'=>$end_time,'ip'=>getip()]);
                $end_time = date("Y-m-d H:i:s",$end_time??'0');
                return json(['code'=>1,'msg'=>'到期时间：'.$end_time]);
            }elseif ($kami['end_time'] < time() ){
                return json(['code'=>-1,'msg'=>'卡密已过期！']);
            }else{
                $end_time = date("Y-m-d H:i:s",$kami['end_time']??'0');
                return json(['code'=>1,'msg'=>'到期时间：'.$end_time]);
            }
        }
    }
}