<?php
namespace app\mz_chacm\controller;
use think\facade\Db;
use think\facade\View;
use vitphp\admin\controller\BaseController;

/**
 * @title 系统设置
 */
class Setup extends BaseController
{
    /**
     * @title 城市列表
     */
    public function index(){
        $sheng = Db::name('mz_chacm_province')->select()->toArray();
        View::assign([
           'sheng' => $sheng
        ]);
        return View::fetch();
	}
    /**
     * @title 编辑规则
     */
	public function edit(){
        $id = input('id');
        $sheng = Db::name('mz_chacm_province')->where(['id'=>$id])->find();
        if($this->request->isPost()){
            $post = $this->request->post();
            if(!$post['min']) $this->error('请输入最小数');
            if(!$post['max']) $this->error('请输入最大数');
            Db::name('mz_chacm_province')->where('id',$id)->update(['min'=>$post['min'],'max'=>$post['max']]);
            $this->success('操作成功');
        }
        View::assign([
            'sheng' => $sheng
        ]);
        return View::fetch();
    }
}